﻿<%@ Control Language="C#" AutoEventWireup="true" CodeBehind="CommentModeration.ascx.cs" Inherits="umbraco.blog4.plugins.dashboard.CommentModeration" %>
<%@ Register Assembly="System.Web.Extensions, Version=1.0.61025.0, Culture=neutral, PublicKeyToken=31bf3856ad364e35" Namespace="System.Web.UI" TagPrefix="asp" %>
<%@ Register Namespace="umbraco.uicontrols" Assembly="controls" TagPrefix="umb" %>

<style type="text/css">
    .comment-select {float:left;}
    .comment-gravatar {float:left; margin-right:8px;}
    .comment-actions {float:right; width: 150px;}
    .comment-data {margin-left: 30px;}
    #comments-options {margin-top:5px; padding:5px;}
    #comments-paging {padding:5px;}
    .comment {padding-top:5px; padding-left:5px; border-bottom: solid 1px #CCCCCC;}
    .spamTrue {background-color: #FFFFE0;}
    #bulkactions {float:right;}
</style>
<script type="text/javascript" language="javascript">
    function commentconfirm_delete() {
        if (confirm("Are you sure you want to delete this comment and any child comments?") == true)
            return true;
        else
            return false;
    }
</script>
<asp:UpdatePanel ID="UpdatePanel1" runat="server">
    <ContentTemplate>
        <umb:Pane runat="server" Text="Comment moderation">
            <div id="comments-options">
                <div id="bulkactions">
                    <asp:Label ID="Label1" runat="server" AssociatedControlID="drpCurrentBlog">Current Blog:</asp:Label>
                    <asp:DropDownList ID="drpCurrentBlog" runat="server" 
                        AutoPostBack="True" DataSourceID="blogObjectDataSource" 
                        DataTextField="BlogName" DataValueField="Id"></asp:DropDownList>
                        <asp:ObjectDataSource runat="server" ID="blogObjectDataSource" 
                        DataObjectTypeName="umbraco.blog4.Blog"
                        TypeName="umbraco.blog4.BlogLibrary"
                        SelectMethod="GetBlogsForCurrentUser"></asp:ObjectDataSource>
                        <asp:ObjectDataSource runat="server" ID="commentsObjectDataSource" 
                        DataObjectTypeName="umbraco.blog4.Comment"
                        TypeName="umbraco.blog4.BlogLibrary"
                        SelectMethod="GetCommentsForBlog">
                        <SelectParameters>
                            <asp:ControlParameter Name="Id" DefaultValue="-1" ControlID="drpCurrentBlog" PropertyName="SelectedValue" /> 
                            <asp:Parameter Name="flattenComments" DefaultValue="true" /> 
                            <asp:Parameter Name="filter" DefaultValue="" />
                        </SelectParameters>
                        </asp:ObjectDataSource>
                    &nbsp;&nbsp;
                    <asp:Label ID="lblSelected" runat="server">With Selected: </asp:Label>
                    <asp:LinkButton ID="btnHideAllSelected" runat="server" onclick="btnHideAllSelected_Click">Hide</asp:LinkButton> | 
                    <asp:LinkButton ID="btnShowAllSelected" runat="server" onclick="btnUnHideAllSelected_Click"
                         ToolTip="Makes the selected Comments visible on the website">Show</asp:LinkButton> | 
                    <asp:LinkButton ID="btnDeleteSelected" runat="server" onclick="btnDeleteSelected_Click">Delete</asp:LinkButton>
                </div>
                <asp:LinkButton ID="btnApproved" runat="server" onclick="btnApproved_Click">Approved</asp:LinkButton> | 
                <asp:LinkButton ID="btnSpam" runat="server" onclick="btnSpam_Click">Spam</asp:LinkButton> | 
                <asp:LinkButton ID="btnAll" runat="server" onclick="btnAll_Click">All</asp:LinkButton>
                            <br style="clear:both;" />

            </div>
            <div id="comments">
                <asp:Repeater ID="rptComments" runat="server" 
                    DataSourceID="commentsObjectDataSource">
                    <ItemTemplate>
                        <div class='comment spam<%# Eval("IsSpam") %>'>
                            <asp:Label ID="lblID" runat="server" Text='<%# Eval("Id") %>' Visible="false" />
                            <div class="comment-actions">
                                <asp:LinkButton ID="btnDelete" runat="server" CommandArgument='<%# Eval("Id") %>' OnClientClick="return commentconfirm_delete();" OnClick="btnDelete_Click">Delete</asp:LinkButton>
                                <asp:Literal runat="server" Text=" | " />
                                <asp:LinkButton ID="btnToggleState" runat="server" CommandName='<%# Eval("IsSpam").ToString() %>' CommandArgument='<%# Eval("Id") %>' Text='<%# GetToggleStateText(Eval("IsSpam")) %>' OnClick="btnToggleState_Click" />
                                <asp:Literal runat="server" Text=" | " Visible='<%# !Convert.ToBoolean(Eval("IsSpam")) %>' />
                                <asp:LinkButton ID="btnPublish" runat="server" Visible='<%# !Convert.ToBoolean(Eval("IsSpam")) %>' CommandName='<%# Eval("IsPublished").ToString() %>' CommandArgument='<%# Eval("Id") %>' Text='<%# GetTogglePublishedStateText(Eval("IsPublished")) %>' OnClick="btnTogglePublishedState_Click" />
                            </div>
                            <div class="comment-select">
                                <asp:CheckBox ID="cbSelectComment" runat="server" />
                            </div>
                            <div class="comment-data">
                                <p class="comment-author">
                                    <div class="comment-gravatar">
                                        <img src='<%# Eval("GravatarURL") %>?s=32' width="32" height="32" alt="avatar" />
                                    </div>
                                    <strong><%# Server.HtmlEncode(Eval("Name").ToString()) %></strong><br/>
                                    <a href='<%# Eval("Website") %>' target='_blank'><%# Server.HtmlEncode( Eval("Website").ToString()) %></a> | <a href='mailto:<%# Eval("Email") %>'><%# Server.HtmlEncode(Eval("Email").ToString()) %></a>
                                </p>
                                <p><%# Eval("Text").ToString().Replace("\n", "<br/>")%></p>
                                <p>On  <%# GetPageDetails(Eval("Post.Id")) %> , <%# Eval("Created") %></p>
                            </div>
                            <br style="clear:both;" />
                        </div>
                    </ItemTemplate>
                </asp:Repeater>
                <div id="comments-paging">
                    <asp:Repeater ID="rptPages" runat="server">
                        <ItemTemplate>
                            <asp:LinkButton ID="btnPage" CommandName="Page" CommandArgument="<%#Container.DataItem %>" CssClass="text" runat="server"><%# Container.DataItem %></asp:LinkButton>
                        </ItemTemplate>
                    </asp:Repeater>
                </div>
            </div>
        </umb:Pane>
    </ContentTemplate>
</asp:UpdatePanel>